#! /usr/bin/python

import sys
import string
import shelve
import os
import time

default_supports = [ '0.0025', '0.003', '0.0035', '0.0045', '0.0075' ]
datadir = '../data/'
f  = open(datadir + 'datafiles', 'r')
datafiles = f.readlines()

d = shelve.open( 'serial-time.dbm' )

for x in datafiles:
    xl = string.split(x)
    datafile = xl[0]
    numtxn = int(xl[1])
    path = string.split(datafile,'/')
    filename = path[len(path)-1]
    dataname = filename[0:string.rfind(filename,'.')]
    fp = open('serial/' + dataname + '.time', 'w')
    if len(xl) > 2:
        supports = xl[2:]
    else:
        supports = default_supports
    for epsilon in supports:
        time1 = d['fpgrowth-tiny:' + datafile + ':' + epsilon]
        time2 = d['fpgrowth:' + datafile + ':' + epsilon]
        e_percent = float(epsilon) * 100.0
        fp.write(str(e_percent) + ' ' + str(time1) + ' ' + str(time2) + '\n')
    fp.close()
d.close()
