#! /usr/bin/python
# perform analysis on problem instances and store results in a database
# avoiding multiple invocations of the same instance

import sys
import string
import shelve
import os
import time

default_supports = [ '0.0025', '0.003', '0.0035', '0.0045', '0.0075' ]
datadir = '../data/'
f  = open(datadir + 'datafiles', 'r')
datafiles = f.readlines()

d = shelve.open( 'serial-time.dbm' )

def timeit (key, cmd) :
    print 'running', cmd
    t_s = time.time()
    ret = os.system(cmd)
    t_e = time.time()
    if ret==0:
        delta = t_e - t_s
        print '* successful execution, time elapsed: ', delta
        d[key] = delta
    else:
        print '*** ERROR!!!'

# generate problem instances

for x in datafiles:
    xl = string.split(x)
    datafile = xl[0]
    numtxn = int(xl[1])
    if len(xl) > 2:
        supports = xl[2:]
    else:
        supports = default_supports
    for epsilon in supports:
        support = int ( numtxn * float(epsilon) )
        key =  'fpgrowth-tiny:' + datafile + ':' + epsilon
        args = datadir + datafile + ' ' + str(support) + ' out'
        cmd = '../bin/fpgrowth-tiny ' + args
        if not d.has_key(key):
            timeit(key,cmd)
        key =  'fpgrowth:' + datafile + ':' + epsilon
        args = datadir + datafile + ' 3 ' + str(support) + ' out'
        cmd = '../aux/fpgrowth/fpgrowth ' + args
        if not d.has_key(key):
            timeit(key,cmd)
d.close()
