//
//
// C++ Implementation for module: Count
//
// Description: 
//
//
// Author: exa
//
// Copyright: See COPYING file that came with this distribution
//
//

#include "Count.hxx"
#include "transaction-db/Transaction_Set.hxx"

TS_Counter::TS_Counter(Transaction_Set& ts)
  : transaction_set(ts)
{}

TS_Counter::TS_Counter(const string& prefix, Transaction::File_Format f)
  : db_prefix(prefix),
    transaction_set_ext(prefix.c_str(), f),
    transaction_set(transaction_set_ext)
{}

void TS_Counter::count_items_relative(float sup)
{
  real_support = sup;
  relative_support = true;
  count_items(count);
  large_items();
}

void TS_Counter::count_items_absolute(int sup)
{
  support = sup;
  relative_support = false;
  count_items(count);
  large_items();
}

void TS_Counter::large_items()
{
  int i = 0;
  for (vector<int>::iterator s=count.begin();
       s!=count.end(); s++, i++) {
    if (*s >= support) {
      F.insert(i);
    }
  }
}

void TS_Counter::count_items(vector<int>& count)
{
  //   ifstream ts(pardb_name(db_prefix).c_str(), ios::binary);
  //   num_transactions = Transaction_Set::count_items(ts, count);
  fill(count.begin(), count.end(), 0);
  int num_trans = 0;
  // start scanning
  Transaction_Set::Scanner scanner(transaction_set);
  // do a pass over transaction set
  while (!scanner.end()) {
    Transaction t_i;
    if (scanner.read(t_i)) {
      num_trans++;
      for (Transaction::iterator i=t_i.begin(); i!=t_i.end(); i++) {
	if ( (unsigned int)*i >= count.size() ) {
	  //cout << *i << " > " << count.size() << endl;
	  int oldsize = count.size();
	  int nusize = (*i)+1;
	  if (oldsize < nusize) {
	    count.resize(nusize);
	    for (int j=oldsize; j<nusize; j++) {
	      count[j] = 0;
	    }
	  }
	}
	count[*i]++;
      }
    }
  }

  num_items = count.size();
  num_transactions=num_trans;

  cerr << "|I| = " << num_items  << endl;
  cerr << "|T|=" << num_trans << " ";

  if (relative_support)
    support = (int) trunc(num_transactions * real_support);

}
