//
//
// C++ Interface for module: Count
//
// Description:
//
//
// Author: exa
//
// Copyright: See COPYING file that came with this distribution
//
//

#ifndef Count_Interface
#define Count_Interface

#include "generic/General.hxx"

#include "transaction-db/Transaction_Set.hxx"

// Configuration switches
// GRAPH_2ITEMS
// DIST_PRUNE

typedef vector< vector<int> > Counts;

class TS_Counter {
public:
  TS_Counter(Transaction_Set& ts);
  TS_Counter(const string& prefix, Transaction::File_Format format);
  TS_Counter(TS_Counter& counter, set<int> items);

  void count_items_relative(float sup);
  void count_items_absolute(int sup);

  int num_items;
  int num_transactions;
  float real_support;
  int support;

  void count_1_items();
  void large_items();
  bool freq_item(int i);

  vector<int> count;

  set<int> F;			// frequent 1-items

  string db_prefix;

  void count_items(vector<int>& count);

private:
  void count_items();
  bool relative_support;
  Transaction_Set transaction_set_ext;
  Transaction_Set & transaction_set;
};

inline bool TS_Counter::freq_item(int i)
{
  return count[i]>=support;
}

#endif
