//
//
// C++ Implementation for module: check-ts
//
// Description: 
//
//
// Author: exa
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include "generic/General.hxx"
#include "transaction-db/Transaction_Set.hxx"

int main(int argc, char *argv[])
{
    cout << "check-ts -- verify a transaction set" << endl;

    if (argc!=2) {
      cout << "usage: check-ts <transaction-db>" << endl;
      exit(-1);
    }

    string db_name(argv[1]);
    cout << "checking transaction set " << db_name << endl;
    ifstream in(db_name.c_str(), ios::binary);

    // do a pass over local db.
    int num_trans = 0;
    int max_item = 0;
    int sum_size = 0;
    while (!in.eof()) {
      Transaction t_i;
      if (t_i.read(in, Transaction::ascii)) {
	num_trans++;
	for (Transaction::iterator i=t_i.begin(); i!=t_i.end(); i++) {
	  if (*i>max_item) max_item=*i;
	}
	sum_size += t_i.size();
      }
      else {
	cout << "last transaction" << endl;
	break;
      }
    }
    cout << "|T| =" << num_trans << endl;
    cout << "|I| = " << max_item + 1 << endl;
    cout << "|t|_avg = " << float(sum_size) / num_trans << endl;
    cout << "transaction set valid" << endl;

    return 0; // success
};
